package main

import (
	"time"
)

type Product struct {
	id         int       `ksql:"id"`
	system     string    `ksql:"system"`
	barcode    string    `ksql:"barcode"`
	created_at time.Time `ksql:"created_at,timeNowUTC"`
}

type WorkerType int

const (
	Barnivore WorkerType = iota
)

type EvidenceType int

const (
	ManufactureWebsite EvidenceType = iota
	IngredientsList
)

type Claim int

const (
	ContainsMeat Claim = iota
	ContainsFish
	ContainsEggs
	ContainsMilk
	ContainsHoney
	ContainsWax
	ContainsFur
	ContainsLeather
	ContainsAnimalFibers
	ContainsWool
	ContainsFeathers
	AnimalTesting
	MonkeySlavery
)

type AutomatedClaim struct {
	id            int        `ksql:"id"`
	product_id    int        `ksql:"product_id"`
	worker_type   WorkerType `ksql:"worker_type"`
	evidence      struct{}   `ksql:"evidence,json"`
	claim         Claim      `ksql:"claim"`
	counter_claim Claim      `ksql:"counter_claim"`
	created_at    time.Time  `ksql:"created_at,timeNowUTC"`
}

type UserClaim struct {
	id            int          `ksql:"id"`
	product_id    int          `ksql:"product_id"`
	evidence_type EvidenceType `ksql:"evidence_type"`
	evidence      struct{}     `ksql:"evidence,json"`
	claim         Claim        `ksql:"claim"`
	counter_claim Claim        `ksql:"counter_claim"`
	created_at    time.Time    `ksql:"created_at,timeNowUTC"`
	created_by    string       `ksql:"created_by"`
}
